package RPM::Source::Transformation::EarlyResource::GearRules;

use strict;
use warnings;

use RPM::Source::Transformation::EarlyResource;
our @ISA=qw/RPM::Source::Transformation::EarlyResource/;

our $VERSION=0.001;
our $verbose=0;

# no need - no cli options exported
#push @RPM::Source::TransformContainer::SUPPORT_CLASSES, __PACKAGE__;

package Source::Shared::ResourceContainer;

use strict;
use warnings;

use Carp;
use Cwd qw/cwd/;
use Gear::Rules 0.197;

sub set_cached_gear_rules {
    my ($resourceobj, $rules)=@_;
    $resourceobj->{'__gear_rules_cache'}=$rules;
}

sub get_cached_gear_rules {
    my ($resourceobj,$spec)=@_;
    my $gear_rules_cache=$resourceobj->{'__gear_rules_cache'};
    return $gear_rules_cache if $gear_rules_cache;
    my $curdir=cwd();
    my $geardir=$spec->{GEARDIR};
    Carp::confess "internal error: access to gear_rules_cache, but GEARDIR not found" unless $geardir;
    chdir $geardir;
    my $rules=Gear::Rules->new();
    chdir $curdir;
    $resourceobj->{'__gear_rules_cache'}=$rules;
    print STDERR "DEBUG: gear_rules_cache: created gear_rules_cache\n" if $RPM::Source::Transformation::EarlyResource::GearRules::verbose>1;
    return $rules;
}

1;
