package RPM::Source::Transformation::Provider::Name2Spec::GirarNMU::InGear;

use strict;
use warnings;

use Cwd qw/abs_path cwd/;
use File::Path qw(make_path remove_tree);
use Gear::Rules 0.197;

use RPM::Source::Transformation::RPMEditorProvider;
use RPM::Source::Transformation::Provider::Name2Spec::GirarNMU::Switch;
use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;
$RPM::Source::TransformContainer::Name2SpecProvider=__PACKAGE__;
$RPM::Source::Transformation::Provider::Name2Spec::GirarNMU::Switch::GEAR_NAME2SPEC_PROVIDER=__PACKAGE__;

use RPM::Source::Transformation::Component::GirarNMU::Options 
    qw/$outgeardir $gitbranch/;

sub process_options {
    my ($class)=@_;
    if (not -d $outgeardir) {
	print STDERR $outgeardir, " directory not found.
$0 should run on the already created directory tree.\n";
	$class->usage();
	exit 1;
    }
}

sub name2spec {
    my (undef,$name,$converter_opt)=@_;
    -d $outgeardir || die $outgeardir, "not found!";
    my $namedgeardir=$outgeardir.'/'.$name.'.git';
    -d $namedgeardir || die "Name2Spec: ", $namedgeardir, "not found.\n";
    my $curdir=cwd();
    chdir $namedgeardir;
    my $rules=Gear::Rules->new();
    # TODO: implement -d $gitbranch check option
    my $specfile=$rules->get_spec();
    $converter_opt->{-name2spec_provided_nvr}=join('-',$rules->get_nvr());
    my $spec=$RPM::Source::TransformContainer::RPMEditorProvider->rpmeditoropts2spec([
	GEARDIR => abs_path('.'),
	SPECFILE=> abs_path($specfile),
    ]);
    chdir $curdir;
    return $spec;
}

1;
