package RPM::Source::Transformation::Writer::GirarNMU;

use strict;
use warnings;

use RPM::Source::Transformation::Component::GirarNMU::Options;
use RPM::Source::Transformation::Writer::Basic;
use RPM::Source::Transformation::Component;
our @ISA=qw/RPM::Source::Transformation::Component/;
$RPM::Source::TransformContainer::WRITER=__PACKAGE__;

$RPM::Source::Transformation::Writer::Basic::opt_gear_git_add_spec=1;
$RPM::Source::Transformation::Writer::Basic::opt_gear_commit_no_edit=1;

our $GEAR_WRITER='RPM::Source::Transformation::Writer::Basic';
our $SRPM_WRITER;
sub cli_container_ref {
    my @refs;
    push @refs, $GEAR_WRITER if $GEAR_WRITER;
    push @refs, $SRPM_WRITER if $SRPM_WRITER;
    return \@refs;
}

our $verbose=0;

sub write {
    my (undef,$spec,$parent,$converter_opt,$resourceobj)=@_;
    my $method=$converter_opt->{-opt_girar_upload_method};
    if ($method eq 'srpm') {
	if ($SRPM_WRITER) {
	    return $SRPM_WRITER->write($spec,$parent,$converter_opt,$resourceobj);
	} else {
	    my $outsrpmdir=$RPM::Source::Transformation::Component::GirarNMU::Options::outsrpmdir;
	    if ($RPM::Source::Transformation::Component::GirarNMU::Options::opt_use_named_subtree_srpms) {
		$converter_opt->{-output_srpm_dir}=$outsrpmdir.'/'.$converter_opt->{-input_handler_arg_input_name};
	    } else {
		$converter_opt->{-output_srpm_dir}=$outsrpmdir;
	    }
	    return RPM::Source::Transformation::Writer::Basic->write($spec,$parent,$converter_opt,$resourceobj);
	}
    } else {
	return $GEAR_WRITER->write($spec,$parent,$converter_opt,$resourceobj);
    }
}

1;
